% Import prbhu kloubovch promnnch polohy, rychlosti a zrychlen - soubor q_dq_ddq.txt
Data1 = importdata('q_dq_ddq.txt');

% Create new variables in the base workspace from those fields.
vars = fieldnames(Data1);
for i = 1:length(vars)
    assignin('base', vars{i}, Data1.(vars{i}));
end
% Poet hodnot prbh
n_index=length(Data1.data);

run struktura;

Time=zeros(n_index,1);
akcni_sila=zeros(3,ndof+1,n_index);
akcni_moment=zeros(3,ndof+1,n_index);
q=zeros(n_index,ndof);
dq=zeros(n_index,ndof);
ddq=zeros(n_index,ndof);
zob_sila=zeros(n_index,ndof);
zob_sila_na2=zeros(n_index,ndof);
Mekv=zeros(1,ndof);
Integr_zob_sila_2=zeros(1,ndof);
zob_sila_1=zeros(n_index,1);
zob_sila_2=zeros(n_index,1);
zob_sila_3=zeros(n_index,1);

Time(:)=Data1.data(:,1);
for i=0:ndof-1
    q(:,i+1)=Data1.data(:,2+3*i);
    dq(:,i+1)=Data1.data(:,3+3*i);
    ddq(:,i+1)=Data1.data(:,4+3*i);
end


J=zeros(3,3,ndof);
J_lok=zeros(3,3,ndof);

J_lok(:,:,1)=[Jx1t -Jxy1t -Jxz1t; -Jxy1t Jy1t -Jyz1t; -Jxz1t -Jyz1t Jz1t];
J_lok(:,:,2)=[Jx2t -Jxy2t -Jxz2t; -Jxy2t Jy2t -Jyz2t; -Jxz2t -Jyz2t Jz2t];
J_lok(:,:,3)=[Jx3t -Jxy3t -Jxz3t; -Jxy3t Jy3t -Jyz3t; -Jxz3t -Jyz3t Jz3t];

f_a=zeros(3,ndof+1);
n_a=zeros(3,ndof+1);
omega=zeros(3,ndof+1);
omega_r=zeros(3,ndof+1);
eps_r=zeros(3,ndof+1);
A=zeros(4,4,ndof+1);
T=zeros(4,4,ndof+1);
R=zeros(3,3,ndof+1);

G=[0;0;-9.80665];

for j=1:n_index

    for i=1:ndof+1
        if i>1 && kin_struc(i-1)=='R'
            theta(i)=q(j,i-1);
        elseif i>1 && kin_struc(i-1)=='T'
            d(i)=q(j,i-1);
        end;
    A(:,:,i)=[cos(theta(i)) -sin(theta(i))*cos(alfa(i))  sin(theta(i))*sin(alfa(i)) a(i)*cos(theta(i));
              sin(theta(i))  cos(theta(i))*cos(alfa(i)) -cos(theta(i))*sin(alfa(i)) a(i)*sin(theta(i));
              0              sin(alfa(i))                cos(alfa(i))               d(i);
              0              0                           0                          1];
    end

    T(:,:,1)=A(:,:,1);
    for i=2:ndof+1
        T(:,:,i)=T(:,:,i-1)*A(:,:,i);
    end

%pozor, koeficienty matic a vektoru k jsou posunuty o +1 - tedy k0=k(:,1)

    for i=1:ndof+1
        k(:,i)=T(1:3,3,i);
    end
    for i=1:ndof+1
    R(:,:,i)=T(1:3,1:3,i);
    end

    for i=1:ndof
        J(:,:,i)=R(:,:,i+1)*J_lok(:,:,i)*transpose(R(:,:,i+1));
    end

    for i=1:ndof
        p(:,i)=T(1:3,4,i+1)-T(1:3,4,i);
        if kin_struc(i)=='R'
            omega_r(:,i)=k(:,i)*dq(j,i);
            eps_r(:,i)=k(:,i)*ddq(j,i);
        else
            omega_r(1:3,i)=[0;0;0];
            eps_r(1:3,i)=[0;0;0];
        end
    end

    Dr=[0 -1 0 0;1 0 0 0;0 0 0 0;0 0 0 0];
    Dt=[0 0 0 0;0 0 0 0;0 0 0 1;0 0 0 0];

    XX=zeros(4,4,ndof);
    v_r=zeros(3,ndof);
    for i=1:ndof
        if kin_struc(i)=='R'
           XX=Dr*A(:,:,i+1)*dq(j,i);
        elseif kin_struc(i)=='T'
           XX=Dt*A(:,:,i+1)*dq(j,i);
        end
        v_r(:,i)=R(:,:,i)*XX(1:3,4);
    end

    for i=2:ndof+1
        omega(:,i)=omega(:,i-1)+omega_r(:,i-1);
    end
    v=zeros(3,ndof+1);
    eps=zeros(3,ndof+1);
    for i=2:ndof+1
        v(:,i)=v(:,i-1)+v_r(:,i-1)+cross(omega(:,i-1),p(:,i-1));
        eps(:,i)=eps(:,i-1)+eps_r(:,i-1)+cross(omega(:,i-1),omega(:,i-1));
    end

    a_r=zeros(3,ndof);
    for i=1:ndof
        if kin_struc(i)=='R'
            a_r(:,i)=cross(eps_r(:,i),p(:,i))+cross(omega_r(:,i),cross(omega_r(:,i),p(:,i)));
        else
            a_r(:,i)=k(:,i)*ddq(j,i);
        end
    end

    a=zeros(3,ndof+1);
    for i=2:ndof+1
        a(:,i)=a(:,i-1)+a_r(:,i-1)+cross(eps(:,i-1),p(:,i-1))+2*cross(omega(:,i-1),v_r(:,i-1))+cross(omega(:,i-1),cross(omega(:,i-1),p(:,i-1)));
    end

    for i=1:ndof
        ptb(:,i)=R(:,:,i+1)*pt(:,i);
    end

%pozor vechny rychlosti a zrychlen maj posunut index - index 1 m
%nap. omega(:,0)

    vt=zeros(3,ndof+1);
    at=zeros(3,ndof+1);
    for i=2:ndof+1
        vt(:,i)=v(:,i)+cross(omega(:,i),ptb(:,i-1));
        at(:,i)=a(:,i)+cross(eps(:,i),ptb(:,i-1))+cross(omega(:,i),cross(omega(:,i),ptb(:,i-1)));
    end

    for i=ndof:-1:1
        f_a(:,i)=m(i)*(G-at(:,i+1))+f_a(:,i+1);
    end

    for i=ndof:-1:1
        N(:,i)=-(J(:,:,i)*eps(:,i+1)+cross(omega(:,i+1),(J(:,:,i)*omega(:,i+1))));
        n_a(:,i)=n_a(:,i+1)+N(:,i)+cross((p(:,i)+ptb(:,i)),f_a(:,i))-cross(ptb(:,i),f_a(:,i+1));
    end
    
    %prvn index komponent, druh slo kloubu, tet as index
    akcni_sila(:,:,j)=f_a(:,:);
    akcni_moment(:,:,j)=n_a(:,:);


    
    for i=1:ndof
        if kin_struc(i)=='R'
            zob_sila(j,i)=-n_a(:,i)'*k(:,i);
        else
            zob_sila(j,i)=-f_a(:,i)'*k(:,i);
        end
        zob_sila_na2(j,i)=zob_sila(j,i)^2;
        Integr_zob_sila_2(i)=Integr_zob_sila_2(i)+zob_sila_na2(j,i);
    end


    %Vstupn vykreslen prbh sil a moment - pklad pro ti DOF, pro vce
    %kloub doplnit
    %Vytvoen sloek sil a moment - prvn index komponent, druh kloub,
    %tet as
    zob_sila_1(j)=zob_sila(j,1);
    zob_sila_2(j)=zob_sila(j,2);
    zob_sila_3(j)=zob_sila(j,3);
    
end

Mekv=sqrt(Integr_zob_sila_2/n_index);

figure
T1=strcat('Zobecnn sla prvn kloub a Mekv  =',num2str(Mekv(1)),' N (podlit pevodem na motor)');
T2=strcat('Zobecnn sla druh kloub a Mekv  =',num2str(Mekv(2)),' N (podlit pevodem na motor)');
T3=strcat('Zobecnn sla tet kloub a Mekv  =',num2str(Mekv(3)),' N (podlit pevodem na motor)');
subplot(3,1,1);plot(Time,zob_sila_1,Time, Mekv(1));
title(T1);
subplot(3,1,2);plot(Time,zob_sila_2,Time, Mekv(2));
title(T2);
subplot(3,1,3);plot(Time,zob_sila_3,Time, Mekv(3));
title(T3);



